; 

    .686
    .mmx
    .MODEL FLAT,STDCALL
    OPTION CASEMAP:NONE

  
    include \masm32\include\windows.inc
    include \masm32\macros\timers.asm      
    include \masm32\macros\macros.asm    
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\shlwapi.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\shlwapi.lib

    InStringL proto :DWORD, :DWORD
    finstr    PROTO :DWORD,:DWORD,:DWORD

; 

.data
 ; Mainstr db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wings",0
 ; Substrx  db "wings",0

Mainstr db "beware of the ides of march",0
Substrx  db "ides of march",0


cl1 dd 0
cl2 dd 0
cl3 dd 0

.data?
NTstrstr dd ?

.code
start:

; 

  REPEAT 8

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke crt_strstr,addr Mainstr,addr Substrx
    counter_end
    add cl1, eax
    print str$(eax)," timing msvcrt strstr",13,10

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,0,addr Mainstr,addr Substrx
    counter_end
    add cl2, eax
    print str$(eax)," timing finstr",13,10

    LOOP_COUNT EQU 1000000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substrx
    counter_end
    add cl3, eax
    print str$(eax)," timing InStringL",13,10

  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3

    print "----------------------",13,10
    print str$(cl1)," average msvcrt strstr",13,10
    print str$(cl2)," average finstr",13,10
    print str$(cl3)," average InStringL",13,10
    print "----------------------",13,10

    inkey

invoke ExitProcess,0

; 
OPTION PROLOGUE:NONE		; turn it off
OPTION EPILOGUE:NONE		;
align 16					;
InStringL	proc	lpSource:DWORD, lpPattern:DWORD
	movd	MM7,	edi		; saving registers
	movd	MM6,	esp		;
	movd	MM5,	ebp		;
	movd	MM3,	esi		;
    mov	edi,	[esp+2*4]	; edi->lpPattern
	mov	eax,	[esp+1*4]	; eax-> lpSource
	lea	esi, 	[edi+1]		; esi->lp Pattern +1
	movq	MM2,	[edi]	; MM2->get the 1st byte of substring
   	movd	MM4,	ebx		;
	punpcklbw	MM2, MM2	; ????????????wwww 
	punpcklwd	MM2, MM2	; ????????wwwwwwww
	movd	ebx,	MM2     ; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov	esp,	0FEFEFEFFh	;              if the 1st byte of the substring is "w"
	movd	MM2,	esi   	; MM2 ->lp Pattern +1
BytesScan:				;
	mov	ecx,	[eax]	;
	mov	esi,	80808080h 
	mov	edi,	[eax+4]	;
@@:						;
	mov	edx,	ecx 	;
	xor	ecx,	ebx		; ebx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov	ebp,	edi		; if the 1st byte of the substring is "w"
	xor	edi,	ebx		;
	add	ecx,	esp		;   
	add	edx,	esp		;
	add	ebp,	esp		;   
	add	edi,	esp		;
	add	eax,	8		;              
	or	edx,	ecx		; testing the 1st byte of substring and 0
	mov	ecx,	[eax]	;         simultaneously    
	or	ebp,	edi		; testing the 1st byte of substring and 0
    mov	edi,	[eax+4]	; 	
    test edx,	esi		;         simultaneously
	jne	@f				;
    test ebp,	esi		; 
  	je	@b				; 
						;
    cmp	[eax-4], bl		; bl ->1st byte of pattern
	je	Minus_3			;
    cmp	byte ptr [eax-4], 0	;
	je	Exit_B			;
	cmp	[eax-3], bl		;
	je	Minus_2			;
    cmp	byte ptr [eax-3], 0	;
	je	Exit_B			;
	cmp	[eax-2], bl		;
	je	Minus_1			;
    cmp	byte ptr [eax-2], 0	;
	je	Exit_B			;
	cmp	[eax-1],  bl	;
	je	Minus_0			;
	cmp	byte ptr [eax-1], 0	; is it the end of the larger string?
	jne	@b				; no, loop again
	xor	eax, eax		; eax=0 -> flag not found	
	je	@not_found
@@:						;
    cmp	[eax-8], bl		; bl ->1st byte of pattern
	je	Minus_7			;
   	cmp	byte ptr [eax-8], 0	;
	je	Exit_B			;
	cmp	[eax-7], bl		;
	je	Minus_6			;
    cmp	byte ptr [eax-7], 0	;
	je	Exit_B			;
	cmp	[eax-6], bl		;
	je	Minus_5			;
    cmp	byte ptr [eax-6], 0	;
	je	Exit_B			;
	cmp	[eax-5],  bl	;
	je	Minus_4			;
	cmp	byte ptr [eax-5], 0	; is it the end of the larger string?
	jne	@b				; no, loop again
Exit_B:					;
	xor	eax,	eax		; eax=0 -> flag not found	
	je	@not_found
Minus_7:
	add	eax,	-7
	jne	Minus_0
Minus_6:
	add	eax,	-6
	jne	Minus_0
Minus_5:
	add	eax,	-5
	jne	Minus_0
Minus_4:
	add	eax,	-4
	jne	Minus_0
Minus_3:
	add	eax,	-3
	jne	Minus_0
Minus_2:
	add	eax,	-2
	jne	Minus_0
Minus_1:
	add	eax,	-1
Minus_0:
	movd	esi,	MM2		; MM2 ->lp Pattern +1
	xor		ecx,	ecx
	movzx	edx,	byte ptr  [esi]
	add		esi,	1
	test	dl,		dl
	je	@found	
;CMP rest  of strings ..;
@@:
	cmp		dl,		[eax+ecx]
	jne		BytesScan
	mov		dl,		[esi+ecx]
	add		ecx,	1
	test	dl,		dl
	jne		@b	
@found:	
	add	eax,	-1			; eax-> address of 1st occurrence  
@not_found:
	movd	edi,	MM7		; restoring registers
	movd	esp,	MM6		;
	movd	ebp,	MM5		;
   	movd	ebx,	MM4		;
	movd	esi,	MM3		;
	ret		2*4				;
InStringL	endp			;
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov ebp, 1
    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    add esi, [esp+4]                ; spos
    sub esi, ebp

; --------------------

  align 16
  scanloop:
  REPEAT 15
    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jz no_match
  ENDM

    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jnz scanloop
    jmp no_match

; --------------------

  align 16
  prematch:
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 7
    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
  ENDM

    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
    jmp matchloop

; --------------------

  match:
    sub esi, [esp+8]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start


